//+------------------------------------------------------------------+
//|                                                 euroform-exp.mq4 |
//|                Copyright  2006, Nick Bilak, beluck[AT]gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Nick Bilak"
#property link      "http://www.mql4.info/"
#include <stdlib.mqh>

#define MODE_DEMA    4
#define MODE_TEMA    5
#define MODE_T3MA    6
#define MODE_JMA     7
#define MODE_HMA     8
#define MODE_DECEMA  9
#define MODE_SATL    10
#define MODE_TMA     11
#define MODE_FATL    12
#define MODE_RSTL    13
#define MODE_SDL     14
#define MODE_Kaufman2 15
#define MODE_NonLagMA 16

extern int expertId=197893;
extern string EAName="euroform";

extern int _3bartrailpips=100;
extern double ProfitExit = 0.07; //% profit exit
extern int BreakEven=6;
extern int ATRStopPeriod = 10;
extern double ATRStopRatio = 2.1;
extern double ATRBreakevenStopRatio = 2.2;
extern int ATREnrtyPeriod = 10;
extern double ATREntryRatio = 2;

extern int First_Target = 20;
extern int Target_Increment = 20;
extern double Close_Lots = 0.01;
extern bool Move_Stops = true;
extern int First_Stop_Target = 19;
extern int First_Stop = 1;
extern int Second_Stop_Target = 39;
extern int Second_Stop = 20;
extern int Third_Stop_Target = 59;
extern int Third_Stop = 30;
extern int Trail_Stop_By = 30;
extern bool Use_Max_Loss = true;
extern int Max_Loss = 100;

extern string i0="_indicators params_";
extern string i1="__volatility__";
extern int rtP=7;
extern int Voltrp=9;
extern int Voltype=1;
extern double  VolatilityHL=25;

extern string i2="__rsi2ma__";
extern int MA1pr=2;
extern int MA1type=14;
/*
MODE_SMA       0     Simple moving average, 
MODE_EMA       1     Exponential moving average, 
MODE_SMMA      2     Smoothed moving average, 
MODE_LWMA      3     Linear weighted moving average.
MODE_DEMA      4     Double Exponential Moving Average. 
MODE_TEMA      5     Triple Exponential Moving Average.
MODE_T3MA      6     T3 Moving Average. 
MODE_JMA       7     Jurik Moving Average. 
MODE_HMA       8     Hull Moving Average. 
MODE_DECEMA    9     DECEMA Moving Average. 
MODE_SALT      10    Slow Adaptive Trend Line
MODE_TMA       11    Triangular moving average
MODE_FATL      12    Fast Adaptive Trend Line. 
MODE_RSTL      13    Referance Slow Trend Line 
MODE_SDL       14    Slope Directional Line
MODE_Kaufman2  15    Kama / Kaufman2 Indicator
MODE_NonLagMA  16    NonLagMA 
*/
extern int MA2pr=8;
extern int MA2type=1;
extern int RSItpr=6;
extern double  MAofRSIUpHL=75;
extern double  MAofRSIDwnHL=25;

extern double MovingPeriod       = 200;
extern double MovingShift        = 6;

extern int       barsToCount = 2000;

extern string i3="__deltastop__";
extern int     Mode=1; //0 - auto, 1 - manual
extern double  DeltaPrice=0.001;
extern int     ATRperiod=14;
extern double  ATRratio=2.824;

extern int    ConsecutiveTrades=3;

extern double Lots = 0.01;
extern int    LotRound=1; //digits after decimal point for lot size
extern double MinLot = 0.01;    //minimum lot size
extern double MaximumRisk = 2; //% risk. lot size will be calculated so that stoploss was equal to risk% of balance
extern bool   FixedLot = false; //trigger to use MM

extern int    slippage=2;   	//slippage for market order processing
extern int    shift=1;			//shift to current bar for entry 
extern int    OrderTriesNumber=3;

bool buysig,sellsig,closebuy,closesell,cancel,addbuy,addsell,exit,tickvalue,Long1,Long2,Long3,Long4,Short1,Short2,Short3,Short4; 
int ord,tries,last,buys,sells,SL, BreakEvenStop;
double atrstop,atrentry,_1stentry,entryprice,_1stlots,avgpositionprofit,hbuy,lsell,curprof;
int nextTP;
bool sl;
int range = 5;
int multiplier;
int Trail_Stop;


int init()
  {
   sl=0;
   nextTP = First_Target;
   Trail_Stop = 0;
   getMaxLoss();
  
     //----------------------- GENERATE MAGIC NUMBER AND TICKET COMMENT
//----------------------- SOURCE : PENGIE
   expertId    = subGenerateMagicNumber(expertId, Symbol(), Period());
   tickvalue = MarketInfo(Symbol(),MODE_TICKVALUE);
   
//----
   
 return(0);
 }
//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()  {


      //---- check for history and trading    
   if(Bars<100 || IsTradeAllowed()==false) return;

   ord=CalculateCurrentOrders();
   //---- check for signals
   CheckForSignals();

   if (ord!=0) CheckForClose();

   CheckForOpen();
   Trail3Bar();
   BreakEvenStop(BreakEven,0);
   getSpread();
   getOpenOrders();
   getMaxLoss();
   BreakevenStop();
   
   


}

//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders()  {
   buys=0; sells=0; avgpositionprofit=0; hbuy=0; lsell=99999; curprof=0;
   string symbol=Symbol();
   
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) continue;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==expertId) {
         curprof += OrderProfit()+OrderSwap();
         if(OrderType()==OP_BUY || OrderType()==OP_BUYSTOP)  buys++;
         if(OrderType()==OP_SELL || OrderType()==OP_SELLSTOP) sells++;
         if (OrderType()==OP_BUY) { avgpositionprofit+=OrderClosePrice()-OrderOpenPrice(); hbuy=MathMax(hbuy,OrderOpenPrice()); }
         if (OrderType()==OP_SELL) { avgpositionprofit+=-OrderClosePrice()+OrderOpenPrice(); lsell=MathMin(lsell,OrderOpenPrice()); }
      }
   }
   if (buys+sells!=0) avgpositionprofit=avgpositionprofit/(buys+sells);
//---- return orders volume
   if(buys>0) return(buys);
   else       return(-sells);
}

double LotsRisk(int StopLoss)  { 
   //MM lot size calculation
   int sl=StopLoss;
   if (sl==0) sl=100;
   double lot=Lots;
//---- select lot size
   if (!FixedLot)
      lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk*0.001/sl,LotRound);
   else
      lot=Lots;
//---- return lot size
   if(lot<MinLot) lot=MinLot;
   return(lot);
}

//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForSignals() {

      addsell=false;
      addbuy=false;
      buysig=false;
      sellsig=false;
      closebuy=false;
      closesell=false;
      exit=false;

   	double VolCH=iCustom(NULL,0,"volatility",rtP,Voltrp,Voltype,0,shift);
   	double RSIndex1=iCustom(NULL,0,"rsi2ma",MA1pr,MA1type,MA2pr,MA2type,RSItpr,0,shift);
   	double MAofRSI11=iCustom(NULL,0,"rsi2ma",MA1pr,MA1type,MA2pr,MA2type,RSItpr,1,shift);
   	double MAofRSI21=iCustom(NULL,0,"rsi2ma",MA1pr,MA1type,MA2pr,MA2type,RSItpr,2,shift);
   	double RSIndex2=iCustom(NULL,0,"rsi2ma",MA1pr,MA1type,MA2pr,MA2type,RSItpr,0,shift+1);
   	double MAofRSI12=iCustom(NULL,0,"rsi2ma",MA1pr,MA1type,MA2pr,MA2type,RSItpr,1,shift+1);
   	double MAofRSI22=iCustom(NULL,0,"rsi2ma",MA1pr,MA1type,MA2pr,MA2type,RSItpr,2,shift+1);
   	double TrStop=iCustom(NULL,0,"delta-stop",Mode,DeltaPrice,ATRperiod,ATRratio,0,shift);
   	double zscore=iCustom(NULL,0,"zscore",barsToCount,PRICE_CLOSE,0);
   	double ma=iMA(NULL,0,MovingPeriod,MovingShift,MODE_SMA,PRICE_CLOSE,0);
   	
   	atrstop=iATR(NULL,0,ATRStopPeriod,shift);
   	atrentry=iATR(NULL,0,ATREnrtyPeriod,shift);

      if (ord==0) { _1stentry=-1; _1stlots=0; }
      int numentries;
      if (ord>0) {
         if (atrentry*ATREntryRatio!=0.0) numentries = MathFloor((Ask-_1stentry)/(atrentry*ATREntryRatio));
         if (numentries>ord) addbuy=true;
      }
      if (ord<0) {
         if (atrentry*ATREntryRatio!=0.0) numentries = MathFloor((_1stentry-Bid)/(atrentry*ATREntryRatio));
         if (numentries>(-ord)) addsell=true;
      }
      SL=atrstop*ATRStopRatio/Point;
      
      double VolHL=VolatilityHL;
      double HL1=MAofRSIUpHL;
      double HL2=MAofRSIDwnHL;
      double HLM=50;

      bool Long1 = MAofRSI11>MAofRSI21 && MAofRSI12<=MAofRSI22 && VolCH>VolHL && RSIndex1<HLM && RSIndex1>HL2 && TrStop<Close[shift] && Open[1]>ma;
      
      bool Short1 = MAofRSI11<MAofRSI21 && MAofRSI12>=MAofRSI22 && VolCH>VolHL && RSIndex1<HL1 && RSIndex1>HLM && TrStop>Close[shift] && Open[1]<ma;
      
      bool Long2 = MAofRSI11>HLM && MAofRSI12<=HLM && MAofRSI21>HLM && MAofRSI22<=HLM && VolCH>VolHL && TrStop<Close[shift] && Open[1]>ma;
      
      bool Short2 = MAofRSI11<HLM && MAofRSI12>=HLM && MAofRSI21<HLM && MAofRSI22>=HLM && VolCH>VolHL && TrStop>Close[shift] && Open[1]<ma;
      
      bool Long3 = RSIndex1-RSIndex2>20 && TrStop<Close[shift] && Open[1]>ma;
      
      bool Short3 = RSIndex2-RSIndex1>20 && TrStop>Close[shift] && Open[1]<ma;
      
      bool Long4 = zscore > 0.3 && TrStop<Close[shift] && Open[1]>ma;
      
      bool Short4 = zscore < -0.3 && TrStop>Close[shift] && Open[1]<ma;

      buysig = Long1 || Long2 || Long3 || Long4;
      sellsig = Short1 || Short2 || Short3 || Short4;

      closebuy=sellsig;
      closesell=buysig;
      
      if (curprof>=AccountBalance()*ProfitExit/100.0) {
         exit=true;
         }
       }  

void CheckForOpen() {

   int    res;
   double entry,stop,profit;
   
   if (exit) return;
   
//---- buy conditions
   if (addbuy)  {
		res=OpenAtMarket(OP_BUY,_1stlots);
		if (res<=0) Print("Error opening BUY order : ",ErrorDescription(GetLastError()));
		else AdjustStops();
   }
//---- sell conditions
   if (addsell)  {
		res=OpenAtMarket(OP_SELL,_1stlots);
		if (res<=0) Print("Error opening SELL order : ",ErrorDescription(GetLastError()));
		else AdjustStops();
   }

   if (last==Time[0]) return;

   ord=CalculateCurrentOrders();

   if (ord!=0) CheckForClose();

   ord=CalculateCurrentOrders();

//---- buy conditions
   if (ord==0 && buysig)  {
		res=OpenAtMarket(OP_BUY,LotsRisk(SL));
		if ( Long1 == true)
		if ( Long2 == true)
		if ( Long3 == true)
		if ( Long4 == true)
		if (res<0) Print("Error opening BUY order : ",ErrorDescription(GetLastError()));
		else { last=Time[0]; _1stlots=LotsRisk(SL); _1stentry=entryprice; AdjustStops(); }
   }
//---- sell conditions
   if (ord==0 && sellsig)  {
		res=OpenAtMarket(OP_SELL,LotsRisk(SL));
		if ( Short1 == true)
		if ( Short2 == true)
		if ( Short3 == true)
		if ( Short4 == true)
		if (res<=0) Print("Error opening SELL order : ",ErrorDescription(GetLastError()));
		else { last=Time[0]; _1stlots=LotsRisk(SL); _1stentry=entryprice; AdjustStops(); }
   }
}
  
int OpenAtMarket(int mode,double lot) {
   int    res,tr,col;
   double openprice,sl,tp;
   tries=0;
   while (res<=0 && tries<OrderTriesNumber) {
      tr=0; while (tr<5 && !IsTradeAllowed()) { tr++; Sleep(2000); }
      RefreshRates();
      if (mode==OP_SELL) {
         openprice=Bid; 
         col=Red;
      } else {
         //openprice=nd(Ask);
         openprice=Ask;
         col=Blue;
      }
      entryprice=openprice;
      res=OrderSend(Symbol(),mode,lot,openprice,slippage,sl,tp,EAName+expertId,expertId,0,col);
      tries++;
      Print(" Short1 signal taken ");
      Print(" Short2 signal taken ");
      Print(" Short3 signal taken ");
      Print(" Short4 signal taken ");
      Print(" Long1 signal taken ");
      Print(" Long2 signal taken ");
      Print(" Long3 signal taken ");
      Print(" Long4 signal taken ");
   }
   return(res);
}
  
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()  {
	int total;
	total=OrdersTotal();
   for(int i=total;i>=0;i--) {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))  continue;
      if(OrderMagicNumber()!=expertId || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY && (exit || closebuy)) CloseAtMarket(OrderTicket(),OrderLots());
      if(OrderType()==OP_SELL && (exit || closesell)) CloseAtMarket(OrderTicket(),OrderLots());
   }
   if (exit) last=Time[0];
}

bool CloseAtMarket(int ticket,double lot) {
   bool bres=false; int tr;
   tries=0;
   while (!bres && tries<OrderTriesNumber) {
      tr=0; while (tr<5 && !IsTradeAllowed()) { tr++; Sleep(2000); }
      RefreshRates();
      bres=OrderClose(ticket,lot,OrderClosePrice(),slippage,White);
      if (!bres) Print("Error closing order : ",ErrorDescription(GetLastError()));
      tries++;
   }
}
void AdjustStops() {
   ord=CalculateCurrentOrders();
   bool bres;
   double StopLoss;
   for (int i = 0; i < OrdersTotal(); i++) {
      if ( OrderSelect (i, SELECT_BY_POS) == false )  continue;
      if ( OrderSymbol() != Symbol() || OrderMagicNumber() != expertId )  continue;
      if ( OrderType() == OP_BUY ) {
         StopLoss = nd(hbuy-atrstop*ATRStopRatio);
         if ( StopLoss != OrderStopLoss() ) {
               bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, White);
				   if (!bres) Print("Error Modifying BUY order : ",ErrorDescription(GetLastError()));
         }
      }

      if ( OrderType() == OP_SELL ) {
         StopLoss = nd(lsell+atrstop*ATRStopRatio);
         if ( StopLoss != OrderStopLoss() ) {
               bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, Gold);
				   if (!bres) Print("Error Modifying SELL order : ",ErrorDescription(GetLastError()));
         }
      }
   }
   return;
}
void BreakevenStop() {
   ord=CalculateCurrentOrders();
   bool bres;
   double BEstop;
   double StopLoss=atrstop*ATRBreakevenStopRatio;
   if (avgpositionprofit<StopLoss) return;
   for (int i = 0; i < OrdersTotal(); i++) {
      if ( OrderSelect (i, SELECT_BY_POS) == false )  continue;
      if ( OrderSymbol() != Symbol() || OrderMagicNumber() != expertId )  continue;
      if ( OrderType() == OP_BUY ) {
         BEstop = nd(OrderOpenPrice()-StopLoss);
         if ( BEstop > OrderStopLoss() ) {
               bres=OrderModify (OrderTicket(), OrderOpenPrice(), BEstop, OrderTakeProfit(), 0, White);
				   if (!bres) Print("Error Modifying BUY order : ",ErrorDescription(GetLastError()));
         }
      }

      if ( OrderType() == OP_SELL ) {
         BEstop = nd(OrderOpenPrice()+StopLoss);
         if ( BEstop < OrderStopLoss() ) {
               bres=OrderModify (OrderTicket(), OrderOpenPrice(), BEstop, OrderTakeProfit(), 0, Gold);
				   if (!bres) Print("Error Modifying SELL order : ",ErrorDescription(GetLastError()));
         }
      }
   }
   return;
}

double nd(double d) {
   return(NormalizeDouble(d,Digits));
}



//========== FUNCTION getPipValue
double getPipValue(double ord,int dir)
{
   double val;
   RefreshRates();
   if(dir == 1) val=(NormalizeDouble(ord,Digits) - 
NormalizeDouble(Ask,Digits));
   else val=(NormalizeDouble(Bid,Digits) - NormalizeDouble(ord,Digits));
   val = val/Point;
   return(val);
}
//== end function

int getSpread()
{
   int spread=MarketInfo(Symbol(),MODE_SPREAD);
   return(spread);
}


int getMaxLoss()
{
   int calcMaxLoss;
   calcMaxLoss = Max_Loss;
   return(calcMaxLoss);
}

//========== FUNCTION getOpenOrders
void getOpenOrders()
{
   int nsl, nsd;
   string mngMagic, trailon;
   int totalorders = OrdersTotal();
   for(int j=0; j<totalorders;j++)
     {
         OrderSelect(j, SELECT_BY_POS, MODE_TRADES);
         if((OrderType() == OP_BUY || OrderType() == OP_SELL) && 
OrderSymbol() == Symbol()&&(expertId==0 ||expertId == 
OrderMagicNumber()))
         {

            double val=getPipValue(OrderOpenPrice(),OrderType());
            //int val = OrderProfit()/(OrderLots()*10);
            if(Use_Max_Loss && Max_Loss > 0) killTrade(val,OrderTicket());
            if(Move_Stops) checkStops(val,OrderTicket());
            takeProfit(val,OrderTicket());

         }

         if(expertId == 0)
         mngMagic = "All "+Symbol()+" trades.";
         else
         mngMagic = "Trades with magic number = "+expertId;


         if(sl==0)
            {
               nsl = First_Stop_Target;
               nsd = First_Stop;
               trailon = " ";
            }
         else if(sl==First_Stop)
            {
               nsl = Second_Stop_Target;
               nsd = Second_Stop;
               trailon = " ";
            } 
         else if(sl==Second_Stop)
            {
               nsl = Third_Stop_Target;
               nsd = Third_Stop;
               trailon = " ";
            }
         else if(Trail_Stop_By != 0 && val - Trail_Stop_By > sl)
            {
               nsl = val + 1;
               nsd = val + 1 - Trail_Stop_By; 
               trailon = " ON";  
            }
         //RefreshRates();
         Comment("Order Open: ",OrderOpenPrice(),
         "\nPip Count: ", val,
         "\nNext TP: ", nextTP,
         "\nNext Stop Target: ",nsl,
         "\nNext Stop: ", nsd,
         "\nCurr Stop: ",sl,
         "\nTrail By:  ", Trail_Stop_By, trailon,
         "\nMax Loss: ", getMaxLoss(),
         "\nManaging: ", mngMagic);


     }
}

//========== FUNCTION takeProfit
void takeProfit(int pips, int ticket)
{
   if(OrderSelect(ticket, SELECT_BY_TICKET)==true)
   {

      if(pips >= nextTP && pips < (nextTP + Target_Increment))
      {
         if(OrderType()==1)
         {
            if(OrderClose(ticket, Close_Lots, Ask, 3, YellowGreen))
            nextTP+=Target_Increment;
            else
            Print("Error closing order : ",GetLastError());
         }
         else
         {
            if(OrderClose(ticket, Close_Lots, Bid, 3, YellowGreen))
            nextTP+=Target_Increment;
            else
            Print("Error closing order : ",GetLastError());
         }

      }

   }
}

//== end function



//========== FUNCTION moveStops
void checkStops(int pips,int ticket)
{
   if(sl==0 && pips < Second_Stop_Target)
   {
      if(pips >= First_Stop_Target && pips < (Second_Stop_Target))
      {
         moveStops(ticket, First_Stop);
      }
   }
   else if(sl==First_Stop)
   {
      if(pips >= Second_Stop_Target)
      {
         moveStops(ticket,Second_Stop);
      }
   }
   else if(sl==Second_Stop)
   {
      if(pips >= Third_Stop_Target)
      {
         moveStops(ticket,Third_Stop);
      }
   }
   else if(sl >= Third_Stop && Trail_Stop_By != 0)
   {
      if(pips - Trail_Stop_By > sl)
      {
         Trail_Stop = pips - Trail_Stop_By;
         moveStops(ticket,Trail_Stop);
      }
   }      
}

//== end function

//========== FUNCTION moveStops
void moveStops(int ticket,int stopDiff)
{
   if(OrderSelect(ticket, SELECT_BY_TICKET)==true)
   {
      Print("moveStops called ",ticket, " ",stopDiff);
      if(OrderType()==1)
      {
      OrderModify(ticket,OrderOpenPrice(),OrderOpenPrice()-stopDiff*Point, 
OrderTakeProfit(),0,Plum);
      sl=stopDiff;
      }
      else
      {
      OrderModify(ticket,OrderOpenPrice(),OrderOpenPrice()+stopDiff*Point, 
OrderTakeProfit(),0,Plum);
      sl=stopDiff;
      }
   }



}

//== end function

//========== FUNCTION killTrades
void killTrade(int pips, int ticket)
{
   if(OrderSelect(ticket, SELECT_BY_TICKET)==true)
   {
      if(pips <= -1*getMaxLoss())
      {
         if(OrderType()==1) OrderClose(ticket,OrderLots(),Ask,3,Red);
         else OrderClose(ticket,OrderLots(),Bid,3,Red);
      }
   }
}
//== end function
      
   
   

   

void BreakEvenStop(int BES, int BELP) {
   //move stoploss to lock some profit
   bool bres;
   double StopLoss;
   if ( BES > 2 ) {
      for (int i = 0; i < OrdersTotal(); i++) {
         if ( OrderSelect (i, SELECT_BY_POS) == false )  continue;
         if ( OrderSymbol() != Symbol() || OrderMagicNumber() != expertId )  continue;
         if ( OrderType() == OP_BUY ) {
            if ( Bid < OrderOpenPrice()+BES*Point )  continue;
            StopLoss = OrderOpenPrice()+BELP*Point;
            if ( StopLoss > OrderStopLoss() ) {
                  bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, White);
					   if (!bres) Print("Error Modifying BUY order : ",ErrorDescription(GetLastError()));
            }
         }
   
         if ( OrderType() == OP_SELL ) {
            if ( Ask > OrderOpenPrice()-BES*Point )  continue;
            StopLoss = OrderOpenPrice()-BELP*Point;
            if ( StopLoss < OrderStopLoss() ) {
                  bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, Gold);
					   if (!bres) Print("Error Modifying SELL order : ",ErrorDescription(GetLastError()));
            }
         }
      }
   }
   return;
}


void Trail3Bar() {
   //_3bartrailpips
   bool bres;
   double StopLoss,H3,L3=99999;
   int i=0,cnt=3;
   
   while (i<=cnt) {
      i++;
      if (i>Bars-1) break;
      if (High[i]<=High[i+1] && Low[i]>=Low[i+1]) { cnt++; continue; } //skip inside Bar
      H3=MathMax(H3,High[i]);
      L3=MathMin(L3,Low[i]);
   }
   L3=L3-_3bartrailpips*Point;
   H3=H3+_3bartrailpips*Point;
   double stlev=(1+MarketInfo(Symbol(),MODE_STOPLEVEL))*Point;
   if (L3>=Bid-stlev) L3=Bid-stlev; 
   if (H3<=Ask+stlev) H3=Ask+stlev; 
   for (i = 0; i < OrdersTotal(); i++) {
      if ( OrderSelect (i, SELECT_BY_POS) == false )  continue;
      if ( OrderSymbol() != Symbol() || OrderMagicNumber() != expertId )  continue;
      if ( OrderType() == OP_BUY ) {
         StopLoss = L3;
         if ( StopLoss > OrderStopLoss() ) {
               bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, White);
				   if (!bres) Print("Error Modifying BUY order : ",ErrorDescription(GetLastError()));
         }
      }

      if ( OrderType() == OP_SELL ) {
         StopLoss = H3;
         if ( StopLoss < OrderStopLoss() || OrderStopLoss()<Point ) {
               bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, Gold);
				   if (!bres) Print("Error Modifying SELL order : ",ErrorDescription(GetLastError()));
         }
      }
   }
}
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+--------------------------END OF PROGRAM--------------------------+


//----------------------- GENERATE MAGIC NUMBER BASE ON SYMBOL AND TIME FRAME FUNCTION
//----------------------- SOURCE   : PENGIE

int subGenerateMagicNumber(int MagicNumber, string symbol, int timeFrame)
{
   int isymbol = 0;
   if (symbol == "EURUSD")       isymbol = 1;
   else if (symbol == "GBPUSD")  isymbol = 2;
   else if (symbol == "USDJPY")  isymbol = 3;
   else if (symbol == "USDCHF")  isymbol = 4;
   else if (symbol == "AUDUSD")  isymbol = 5;
   else if (symbol == "USDCAD")  isymbol = 6;
   else if (symbol == "EURGBP")  isymbol = 7;
   else if (symbol == "EURJPY")  isymbol = 8;
   else if (symbol == "EURCHF")  isymbol = 9;
   else if (symbol == "EURAUD")  isymbol = 10;
   else if (symbol == "EURCAD")  isymbol = 11;
   else if (symbol == "GBPUSD")  isymbol = 12;
   else if (symbol == "GBPJPY")  isymbol = 13;
   else if (symbol == "GBPCHF")  isymbol = 14;
   else if (symbol == "GBPAUD")  isymbol = 15;
   else if (symbol == "GBPCAD")  isymbol = 16;
   else                          isymbol = 17;
   if(isymbol<10) MagicNumber = MagicNumber * 10;
   return (StrToInteger(StringConcatenate(MagicNumber, isymbol, timeFrame)));
   
}



